



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS - UIColor</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS - UIColor</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 17:46:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>前言</h1>
<pre class="prettyprint linenums"><code>	NS_CLASS_AVAILABLE_IOS(2_0) @interface UIColor : NSObject &lt;NSSecureCoding, NSCopying&gt;<br />
	@available(iOS 2.0, *)		 public class UIColor : NSObject, NSSecureCoding, NSCopying<br />
</code></pre>
<ul><li>UIColor、CIColor 和 CGColor 出现在不同的类库里面，其实就是颜色存储方式不同而已，比如 999 可以用 10 进制、2 进制、16 进制等存储。三者之间都是能够方便转换的，特别是很多构造函数。</li></ul>
<h1>1、UIColor 的创建</h1>
<ul><li><p>Objective-C</p>
<ul><li><p>使用系统定义好的颜色创建</p>
<pre class="prettyprint linenums"><code>	UIColor *color1 = [UIColor blueColor];

	// 附带设置颜色的透明度<br />
	UIColor *color1 = [[UIColor blackColor] colorWithAlphaComponent:0.5];<br />
</code></pre></li>
<li><p>由白色透明度创建</p>
<pre class="prettyprint linenums"><code>	// alpha：透明度，1 不透明<br />
	UIColor *color2 = [UIColor colorWithWhite:1 alpha:0.5];<br />
</code></pre></li>
<li><p>由三原色创建</p>
<pre class="prettyprint linenums"><code>	// arc4random()%256/255.0 获取小于等于 1 大于 0 的随机数字<br />
	CGFloat red = arc4random()%256/255.0;<br />
	CGFloat green = arc4random()%256/255.0;<br />
	CGFloat blue = arc4random()%256/255.0;

	// Red，green，blue 值的范围是 0 ～ 1，alpha：透明度，1 不透明<br />
	UIColor *color3 = [UIColor colorWithRed:red green:green blue:blue alpha:1];<br />
</code></pre></li>
<li><p>由图片创建</p>
<pre class="prettyprint linenums"><code>	UIColor *color4 = [UIColor colorWithPatternImage:[UIImage imageNamed:@&quot;13&quot;]];<br />
</code></pre></li>
<li><p>由 16 进制字符串创建</p>
<pre class="prettyprint linenums"><code>	NSString *colorString = @&quot;#FF0000&quot;;

	// 十六进制数字字符串转十进制数字<br />
	NSString *s1 = [colorString substringWithRange:NSMakeRange(1, 2)];<br />
	unsigned long c1 = strtoul([s1 UTF8String], 0, 16);

	NSString *s2 = [colorString substringWithRange:NSMakeRange(3, 2)];<br />
	unsigned long c2 = strtoul([s2 UTF8String], 0, 16);

	NSString *s3 = [colorString substringWithRange:NSMakeRange(5, 2)];<br />
	unsigned long c3 = strtoul([s3 UTF8String], 0, 16);

	// Red，green，blue 值的范围是 0 ～ 1，alpha：透明度，1 不透明<br />
	UIColor *color5 = [UIColor colorWithRed:c1/255.0 green:c2/255.0 blue:c3/255.0 alpha:1];<br />
</code></pre></li></ul></li>
<li><p>Swift</p>
<ul><li><p>使用系统定义好的颜色创建</p>
<pre class="prettyprint linenums"><code>	let color1:UIColor = UIColor.blueColor()

	// 附带设置颜色的透明度<br />
	let color1:UIColor = UIColor.blackColor().colorWithAlphaComponent(0.5)<br />
</code></pre></li>
<li><p>由白色透明度创建</p>
<pre class="prettyprint linenums"><code>	// alpha：透明度，1 不透明<br />
	let color2:UIColor = UIColor(white: 1, alpha: 0.5)<br />
</code></pre></li>
<li><p>由三原色创建</p>
<pre class="prettyprint linenums"><code>	// arc4random()%256/255.0 获取小于等于 1 大于 0 的随机数字<br />
	let red:CGFloat = CGFloat(arc4random()%UInt32(256/255.0))<br />
	let green:CGFloat = CGFloat(arc4random()%UInt32(256/255.0))<br />
	let blue:CGFloat = CGFloat(arc4random()%UInt32(256/255.0))

	// Red，green，blue 值的范围是 0 ～ 1，alpha：透明度，1 不透明<br />
	let color3:UIColor = UIColor(red: red, green: green, blue: blue, alpha: 1)<br />
</code></pre></li>
<li><p>由图片创建</p>
<pre class="prettyprint linenums"><code>	let color4:UIColor = UIColor(patternImage: UIImage(named: &quot;13&quot;)!)<br />
</code></pre></li></ul></li></ul>
<h1>2、UIColor 与 CIColor 和 CGColor 的相互转换</h1>
<ul><li><p>Objective-C</p>
<pre class="prettyprint linenums"><code>	// UIColor 转 CGColor<br />
	CGColorRef color = [[UIColor greenColor] CGColor];<br />
</code></pre></li>
<li><p>Swift</p>
<pre class="prettyprint linenums"><code>	// UIColor 转 CGColor<br />
	let color:CGColorRef = UIColor.greenColor().CGColor<br />
</code></pre></li></ul>
<h1>3、由十六进制颜色值创建 RGB 颜色值</h1>
<ul><li><p>具体实现代码见 GitHub 源码 <a href="https://github.com/QianChia/QExtension" rel="external nofollow noreferrer">QExtension</a></p></li>
<li><p>适用于 0Xc83c23、#c83c23、c83c23 格式的十六进制颜色值。</p>
<pre class="prettyprint linenums"><code>	/// 由十六进制颜色值创建 RGB 颜色值，带透明度设置<br />
	+ (UIColor *)colorWithHexString:(NSString *)color alpha:(CGFloat)alpha {

	    NSString *cString = [[color stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]] uppercaseString];

	    // String should be 6 or 8 characters<br />
	    if ([cString length] &lt; 6) {<br />
	        return [UIColor clearColor];<br />
	    }

	    // strip &quot;0X&quot; or &quot;#&quot; if it appears<br />
	    if ([cString hasPrefix:@&quot;0X&quot;])<br />
	        cString = [cString substringFromIndex:2];<br />
	    if ([cString hasPrefix:@&quot;#&quot;])<br />
	        cString = [cString substringFromIndex:1];<br />
	    if ([cString length] != 6)<br />
	        return [UIColor clearColor];

	    // Separate into r, g, b substrings<br />
	    NSRange range;<br />
	    range.location = 0;<br />
	    range.length = 2;

	    // r、g、b<br />
	    NSString *rString = [cString substringWithRange:range];<br />
	    range.location = 2;<br />
	    NSString *gString = [cString substringWithRange:range];<br />
	    range.location = 4;<br />
	    NSString *bString = [cString substringWithRange:range];

	    // Scan values<br />
	    unsigned int r, g, b;<br />
	    [[NSScanner scannerWithString:rString] scanHexInt:&amp;r];<br />
	    [[NSScanner scannerWithString:gString] scanHexInt:&amp;g];<br />
	    [[NSScanner scannerWithString:bString] scanHexInt:&amp;b];

	    return [UIColor colorWithRed:((float) r / 255.0f) green:((float) g / 255.0f) blue:((float) b / 255.0f) alpha:alpha];<br />
	}

	/// 由十六进制颜色值创建 RGB 颜色值<br />
	+ (UIColor *)colorWithHexString:(NSString *)color {

	    return [UIColor colorWithHexString:color alpha:1.0f];<br />
	}<br />
</code></pre>
<pre class="prettyprint linenums"><code>	// 0X 前缀格式<br />
	UIColor *color = [UIColor colorWithHexString:@&quot;0Xc83c23&quot;];<br />
	UIColor *color = [UIColor colorWithHexString:@&quot;0Xc83c23&quot; alpha:0.5];

	// # 前缀格式<br />
	UIColor *color = [UIColor colorWithHexString:@&quot;#c83c23&quot;];<br />
	UIColor *color = [UIColor colorWithHexString:@&quot;#c83c23&quot; alpha:0.5];

	// 无前缀格式<br />
	UIColor *color = [UIColor colorWithHexString:@&quot;c83c23&quot;];<br />
	UIColor *color = [UIColor colorWithHexString:@&quot;c83c23&quot; alpha:0.5];<br />
</code></pre></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mlrj69.html">&lbrack;原创&rsqb;java WEB学习笔记108：Spring学习---基于配置文件的形式实现AOP</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1j4dzq.html">JavaScript函数定义和调用   变量作用域</a>
		</li>
						<li><a href="https://www.batexi.com/a/390e5k4q.html">Web安全</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldo769.html">poj 3278&colon;Catch That Cow（简单一维广搜）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z0xl1q.html">iOS开发工程师面试知识点汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/39ronpe9.html">IOS8修改状态栏颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xxg0z9.html">linux gcc 编译动态类库&lpar;&period;so&rpar;和静态类库&lpar;&period;a&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zjm369.html">wampserver下打开phpMyAdmin出现403错误的问题解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okl52x9.html">&lbrack;ffmpeg 扩展第三方库编译系列&rsqb; 关于需要用到cmake 创建 mingw32编译环境问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xe0pm8.html">HDU 2553   n皇后问题&lpar;回溯法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pov1n8.html">cocos2dx手写js绑定C&plus;&plus;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pddmgz9.html">Android 高仿微信即时聊天 百度云为基础的推</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y7xen8.html">AngularJS事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meymv6q.html">JavaWeb（五）Filter过滤器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojpge5q.html">C语言--第四周作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj0mzk9.html">bzoj 3261最大异或和</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z13pe9.html">scheme深拷贝和浅拷贝探索</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z1rwj9.html">如何在Cocos2D游戏中实现A&ast;寻路算法&lpar;六&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mxwk48.html">【基于url权限管理 shiro&lpar;一&rpar;】--基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zko7x9.html">&commat;PostConstruct和&commat;PreDestroy注解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95xrn468.html">svn     down代码的时候提示&OpenCurlyDoubleQuote;由于目标计算机积极拒绝，无法连接&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xrn568.html">JavaEE基础（七）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1e23j9.html">C&plus;&plus;&colon;FMC 错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0jrr4q.html">&lbrack;ios&rsqb;&lbrack;opengles&rsqb;GLKit如何搭一个app的框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k10zo69.html">C&plus;&plus;陷阱之慎用string类</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm1ylz9.html">HTML学习之canves元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mx5kgq.html">sqlserver2008安装教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydwmw2q.html">关于htons和htonl</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xr4w68.html">Xcode性能优化2</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k10y679.html">Python3基础 type获取变量的类型</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
